#include <display.h>
#include <display_syscalls.h>
#include <keyboard.h>
#include <keyboard_syscalls.h>
#include <color.h>

#include "doodle_main.h"
#include "sprite.h"

#define LCD_WIDTH_PX 384
#define LCD_HEIGHT_PX 216 

#define BASE 0      // Reste de plusieurs tests car j'ai eu un peu de mal à avoir quelque chose de bien
#define SAUT 1
 
int main(void) 
{
    int running = TRUE;
    int frame=1, etat=BASE;
    int force = 75;
    coord doodle = {100, 216-60};
    coord barreC = {170, 216-15}; 
    while (running)
    {
        if(keydown(10))
        {
            running = FALSE ;
        }
        if(keydown(BASIC_GAUCHE))
        {
            doodle.x-=5;
        }
        else if(keydown(BASIC_DROITE))
        {
            doodle.x+=5;
        }
        if(keydown(BASIC_HAUT))
        {
            etat = SAUT;
        }
        calculSaut(&frame, &doodle, &etat);
        Bdisp_AllClr_VRAM();
        CopySpriteMasked(test, doodle.x, doodle.y, 62, 60, 0xf81f);  // 0xf81f étant un rose "fluo" ajouté pour faire de la transparence
        Bdisp_PutDisp_DD();
        OS_InnerWait_ms(1);        
    }
	return 0;
}
void calculSaut(int *frame, coord *coordonnee, int *etat)
{
    int force = 75;       // Système pas réaliste mais pour tester différents trucs...
    if(*etat == SAUT)
    {
        if(*frame <=7)
        {
            coordonnee->y -= (force/7);
            
        }
        if(*frame>7)
        {
            coordonnee->y += (force/7);
            if(*frame == 14)
            {
                *frame = 0;
                *etat = BASE;
            }
        }
    }
    *frame+=1;
    /*double g = 9.8/3;
    int vitesseInitiale = 25;
    if(*etat == SAUT)
    {
        coordonnee->y = 216-(-1/2 * g * pow(*frame, 2) + vitesseInitiale * sin(PI/2) * (*frame));      ### Système réaliste mais non fonctionnel.
        if(coordonnee->y >= 216)
        {
            *etat = BASE;
            coordonnee->y = 216;
            *frame=0;
        }
        *frame++;*/   
}

void afficheFond()
{
    fillArea(0, 0, 384, 216, 0xf77c);
}






// ####################   Cemetech routines ##############################

void fillArea(int x, int y, int width, int height, int color) 
{
   //only use lower two bytes of color
   char* VRAM = (char*)0xA8000000;
   int j, i;
   VRAM += 2*(LCD_WIDTH_PX*y + x);
   for(j=y; j<y+height; j++) {
      for(i=x; i<x+width;  i++) {
         *(VRAM++) = (color&0x0000FF00)>>8;
         *(VRAM++) = (color&0x000000FF);
      }
      VRAM += 2*(LCD_WIDTH_PX-width);
   }
}

void plot(int x0, int y0, int color) 
{
   char* VRAM = (char*)0xA8000000;
   VRAM += 2*(y0*LCD_WIDTH_PX + x0);
   *(VRAM++) = (color&0x0000FF00)>>8;
   *(VRAM++) = (color&0x000000FF);
   return;
}

void drawLine(int x1, int y1, int x2, int y2, int color) 
{
    signed char ix;
    signed char iy;
 
    // if x1 == x2 or y1 == y2, then it does not matter what we set here
    int delta_x = (x2 > x1?(ix = 1, x2 - x1):(ix = -1, x1 - x2)) << 1;
    int delta_y = (y2 > y1?(iy = 1, y2 - y1):(iy = -1, y1 - y2)) << 1;
 
   plot(x1, y1, color);  
    if (delta_x >= delta_y) {
        int error = delta_y - (delta_x >> 1);        // error may go below zero
        while (x1 != x2) {
            if (error >= 0) {
                if (error || (ix > 0)) {
                    y1 += iy;
                    error -= delta_x;
                }                           // else do nothing
         }                              // else do nothing
            x1 += ix;
            error += delta_y;
            plot(x1, y1, color);
        }
    } else {
        int error = delta_x - (delta_y >> 1);      // error may go below zero
        while (y1 != y2) {
            if (error >= 0) {
                if (error || (iy > 0)) {
                    x1 += ix;
                    error -= delta_y;
                }                           // else do nothing
            }                              // else do nothing
            y1 += iy;
            error += delta_x;  
            plot(x1, y1, color);
        }
    }
}


int keydown(int basic_keycode)
{
   const unsigned short* keyboard_register = (unsigned short*)0xA44B0000;
   int row, col, word, bit;
   row = basic_keycode%10;
   col = basic_keycode/10-1;
   word = row>>1;
   bit = col + 8*(row&1);
   return (0 != (keyboard_register[word] & 1<<bit));
}

void CopySpriteMasked(const char* data, int x, int y, int width, int height, int maskcolor) 
{
   int j, i;
   char* VRAM = (char*)0xA8000000;
   VRAM += 2*(LCD_WIDTH_PX*y + x);
   for(j=y; j<y+height; j++) 
   {
      for(i=x; i<x+width;  i++) 
      {
         if ((((((int)(*data))&0x000000FF)<<8) | ((((int)(*(data+1))))&0x000000FF)) != maskcolor) 
         {
            *(VRAM++) = *(data++);
            *(VRAM++) = *(data++);
         } else { VRAM += 2; data += 2; }
      }
      VRAM += 2*(LCD_WIDTH_PX-width);
   }
}